// WebPage.cpp: implementation of the CWebPage class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "WebQuote.h"
#include "WebPage.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CWebPage::CWebPage()
{
	m_Loaded = false;
	m_Session.SetOption( INTERNET_OPTION_CONNECT_RETRIES, 0 );
	m_Session.SetOption( INTERNET_OPTION_CONNECT_TIMEOUT, 1000 );
	m_Session.SetOption( INTERNET_OPTION_RECEIVE_TIMEOUT, 1000 );
	m_Session.SetOption( INTERNET_OPTION_SEND_TIMEOUT, 1000 );

}

CWebPage::~CWebPage()
{

}

BOOL CWebPage::LoadURL(const char *URL)
{
	char Buf[128];
	CHttpFile * pHttpFile;

	if( URL && m_URL.CompareNoCase( URL ) )
		m_URL = URL;

	m_Loaded = false;

	pHttpFile=(CHttpFile*)m_Session.OpenURL( m_URL );
	if( !pHttpFile )
		return( FALSE );
	memset(Buf, 0, sizeof(Buf) );
	while( pHttpFile->Read( Buf, sizeof(Buf)-1 ) != 0 )
	{
		m_Page += Buf;
		memset(Buf, 0, sizeof(Buf) );
	}
	m_Loaded = true;
	return( ParsePage() );
}


BOOL CWebPage::ParsePage()
{
	// Do nothing
	return( TRUE );
}

void CWebPage::RemoveTags(CString &Str)
{
	int Start, Stop;
	while( (Start = Str.Find( "<" ))>=0 && (Stop = Str.Find( ">" ))>=0 )
		Str.Delete( Start, Stop-Start+1 );
}

bool CWebPage::FindAndExtract(const char *Str, bool BeforeAlso)
{
	int Pos;
	if( (Pos=m_Page.Find( Str ))>=0 )
	{
		if( BeforeAlso )
			m_Page.Delete( 0, Pos+strlen(Str) );
		else
			m_Page.Delete( Pos, strlen(Str) );
	}
	return( Pos >= 0 );

}

CString CWebPage::ExtractUntilTag( const char * Tag )
{
	CString Tmp;
	int End;
	if( !Tag )
		Tag = "<";

	End = m_Page.Find( Tag );
	if( End >=0 )
	{
		Tmp = m_Page.Left( End );
		m_Page.Delete( 0, End );
	}
	return( Tmp );
}

BOOL CWebPage::Refresh()
{
	return( LoadURL( 0 ) );
}
