// YahooQuote.cpp: implementation of the CYahooQuote class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "WebQuote.h"
#include "YahooQuote.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CYahooQuote::CYahooQuote()
{
	m_TradeAt;
	m_ChangeA, m_ChangeB;
	m_Volume;

}

CYahooQuote::~CYahooQuote()
{

}

BOOL CYahooQuote::LoadURL( const char* URL )
{
	CString Tmp;
	if( m_Symbol.IsEmpty() && (!URL || !*URL) )
		return( FALSE );
	if( URL && *URL)
		m_Symbol = URL;
	Tmp.Format( "http://finance.yahoo.com/q?s=%s&d=v2", URL );
	return( CWebPage::LoadURL( Tmp ) );
}

BOOL CYahooQuote::ParsePage()
{
	CString Tmp;

	m_Page.MakeUpper();
	if( !m_Loaded )
		return( FALSE );

	/* Version 1.0 Parsing: Removed 4/16/2001

	int Start = m_Page.Find( "MORE INFO" );
	if( !FindAndExtract( "MORE INFO") )
		return( FALSE );
	*/
	
	// Version 1.1 Parsing: Added 4/16/2001
	int Start;
	if( !FindAndExtract( "<A HREF=\"/Q") )
		return( FALSE );

	Start = m_Page.Find( "<TD NOWRAP ALIGN=CENTER>" );
	if( !FindAndExtract( "<TD NOWRAP ALIGN=CENTER>" ) )
		return( FALSE );

	if( !FindAndExtract( "<FONT FACE=ARIAL SIZE=-1>" ) )
		return( FALSE );

	m_LastTradeDate = ExtractUntilTag();

	if( !FindAndExtract( "<TD NOWRAP><FONT FACE=ARIAL SIZE=-1><B>" ) )
		return( FALSE );
	Tmp = ExtractUntilTag( "</B" );
	RemoveTags( Tmp );
	m_TradeAt = FracToFloat( Tmp );
	m_TradeAtStr = Tmp;

	if( !FindAndExtract( "<TD NOWRAP><FONT FACE=ARIAL SIZE=-1>" ) )
		return( FALSE );
	Tmp=ExtractUntilTag( "</FONT></TD" );
	RemoveTags( Tmp );
	m_ChangeA = FracToFloat( Tmp );
	m_ChangeAStr = Tmp;

	if( !FindAndExtract( "<TD NOWRAP><FONT FACE=ARIAL SIZE=-1>" ) )
		return( FALSE );
	Tmp=ExtractUntilTag( "</TD" );
	RemoveTags( Tmp );
	m_ChangeB = (float)atof(Tmp);
	m_ChangeBStr = Tmp;

	if( !FindAndExtract( "<TD NOWRAP><FONT FACE=ARIAL SIZE=-1>" ) )
		return( FALSE );
	Tmp=ExtractUntilTag( "</TD" );
	m_VolumeStr = Tmp;
	while( Tmp.Find(",")>=0 )
		Tmp.Delete( Tmp.Find(",") );
	m_Volume = atoi( Tmp );


	if( !FindAndExtract( "<TD NOWRAP><FONT FACE=ARIAL SIZE=-1>" ) )
		return( FALSE );
	Tmp=ExtractUntilTag( "</TD" );
	m_AvgVolumeStr= Tmp;
	while( Tmp.Find(",") >=0 )
		Tmp.Delete( Tmp.Find(",") );
	m_AvgVolume = atoi( Tmp );

	if( !FindAndExtract( "<TD NOWRAP><FONT FACE=ARIAL SIZE=-1>" ) )
		return( FALSE );
	Tmp=ExtractUntilTag( "</TD" );
	RemoveTags( Tmp );
	m_Open = FracToFloat( Tmp );
	m_OpenStr = Tmp;
	
	return( TRUE );
}



float CYahooQuote::FracToFloat(const char *Str)
{
	double Ret=0.0, A, B;
	bool IsNeg=false;

	while( *Str && *Str ==' ' )
		Str++;
	if( *Str == '-' )
	{
		Str++;
		IsNeg = true;
	}
	else
		if( *Str == '+' )
			Str++;

	while( *Str && *Str ==' ' )
		Str++;

	A = atof( Str );
	while( *Str && *Str != ' ' && *Str != '/' )
		Str++;
	if( !*Str )
		return( float( IsNeg?-A:A) );

	if( *Str == ' ' )
	{
		Ret = A;
		A = 0.0;
	}

	if( *Str )
	{
		if( *Str == '/' )
		{
			B = atof( Str+1 );
			return( (float) (IsNeg? -(Ret + A/B):Ret+A/B ) );
		}
		Str++;
		while( *Str && *Str == ' ' )
			Str++;
		A = atof( Str );
		while( *Str && *Str != '/' )
			Str++;
		if( *Str )
			Str++;
		Ret += A / atof(Str);
	}
	return( (float)(IsNeg?-Ret:Ret) );
}
